--  SOI 2015 Creativity Task 'Bazaar'.
--
--  Sample bot in Ada.
--  contact: sebastian@soi.ch

with Ada.Integer_Text_IO; use Ada.Integer_Text_IO;
with Ada.Numerics.Discrete_Random;

procedure Bot is
   package NaturalRandom is new Ada.Numerics.Discrete_Random(Natural); use NaturalRandom;
   shaker: Generator;
   
   -- Game configuration.
   n, a, d, g: Natural;
   
   procedure init is
      --  Initialize the bot.
   begin
      Reset(shaker);
      Get(n); Get(a); Get(d); Get(g);  
   end init;
   
   procedure playAuction is
      --  Play a single auction.
      bid: Natural;
   begin
      --  Distribute the available gold randomly.
      declare
	 bids: array (1..d) of Natural := (others => 0);
	 players: array (1..n) of Natural := (others => g); 
      begin
	 for coin in 1..g loop
	    declare
	       pick: Natural;
	    begin
	       pick := (Random(shaker) mod n) + 1;
	       bids(pick) := bids(pick) + 1;
	    end;
	 end loop;
      end;
      
      --  Play the auction.
      for round := 1..d loop
	 --  Place the bid.
	 Put(bids(round), width=>1); New_Line; Flush;
	 
	 --  Keep track of every player's gold.
	 players(1) := players(1) - bids(round);
	 for i := 2..n loop
	    Get(bid); players(i) := players(i)-bid;
	 end loop;
      end loop;
   end playAuction;
   
begin
   --  Initialize bot.
   init;
   
   --  Participate in the auctions.
   for auction := 1..a loop
      playAuction;
   end loop;
end Bot;
