// SOI 2015 Creativity Task 'Bazaar'
// Sample bot in C++11 + Boost.Range

#include <iostream>
#include <vector>
#include <random>
#include <boost/range/irange.hpp>

struct memory {
  int players, diamonds, gold;
};

template <typename Rng>
void play_auction(Rng& rng, memory& m){
  std::vector<int> bids(m.diamonds);
  std::uniform_int_distribution<> dist(0, m.diamonds-1);
  for(auto _ : boost::irange(0, m.gold))
    bids[dist(rng)]++;

  std::vector<int> balances(m.players, m.gold);
  for(int round : boost::irange(0, m.diamonds)) {
    std::cout << bids[round] << std::endl;

    balances[0] -= bids[round];
    for (auto i : boost::irange(1, m.players)) {
      int x; std::cin >> x;
      balances[i] -= x;
    }
  }
}

int main() {
  int auctions;
  memory m;
  std::cin >> m.players >> auctions >> m.diamonds >> m.gold;
  
  std::mt19937 rng(std::random_device{}());

  for (auto _ : boost::irange(0, auctions))
    play_auction(rng, m);
}
