/* SOI 2015 Creativity Task 'Bazaar'
 * Sample bot in C++
 * by benjamin@soi.ch
 */

#include <iostream>
#include <vector>
#include <cstdlib>
using namespace std;

class bot {
private:
    int N, D, G;
    vector<int> bids;
    vector<int> playersGold;

public:
    // initialize the bot.
    bot(int n, int d, int g){
        srand(0);
        N = n;
        D = d;
        G = g;
    }

    // plays a single auction.
    // Distributes the available gold randomly on the diamonds.
    void playAuction(){
        bids = vector<int>(D, 0);
        for(int i = 0; i < G; i++){
            bids[rand() % D]++;
        }

        playersGold = vector<int> (N, G);

        for(int i = 0; i < D; i++){
            // endl flushes the output, no need for flush
            cout << bids[i] << endl;

            // Keeps track of all player's gold. Only for demonstration, not used.
            playersGold[0] -= bids[i];
            int tmp;
            for(int j = 1; j < N; j++){
                cin >> tmp;
                playersGold[j] -= tmp;
            }
        }
    }
};

int main() {
    // Read the game parameters and start the bot.
    int N, A, D, G;
    cin >> N >> A >> D >> G;

    bot player = bot(N, D, G);

    for(int i = 0; i < A; i++){
        player.playAuction();
    }

    return 0;
}
