//  SOI 2015 Creativity Task 'Bazaar'.
//
//  Sample bot in C#.
//  contact: sebastian@soi.ch

using System;

class Bot
{
  //  Game configuration.
  readonly int n, a, d, g;

  //  Source of randomness.
  readonly Random shaker = new Random(0);

  //  IO.
  string[] tokens = new string[0];
  int pos = 0;
  private int nextInt()
  {
    //  Read an integer from the console.
    if (pos >= tokens.Length)
    {
      tokens = Console.ReadLine().Split();
      pos = 0;
    }
    return int.Parse(tokens[pos++]);
  }

  Bot()
  {
    //  Initialize the bot.
    n = nextInt(); a = nextInt(); d = nextInt(); g = nextInt();
  }

  private void playAuction()
  {
    //  Play a single auction.
    int[] players = new int[n];
    int[] bids = new int[d];

    //  Distribute the available gold randomly.
    for (int coin=0; coin<g; coin++) ++bids[shaker.Next(0, d)];

    //  Initialize the players: every player starts with the equal amount of money.
    for (int i=0; i<n; i++) players[i] = g;

    //  Play the auction.
    for (int round=0; round<d; round++)
    {
      //  Place the bid.
      Console.WriteLine(bids[round]);
      Console.Out.Flush();

      //  Keep track of every player's gold.
      players[0] -= bids[round];
      for (int i=1; i<n; i++) players[i] -= nextInt();
    }
  }

  public void Play()
  {
    for (int auction=0; auction<a; auction++)
      playAuction();
  }

  static void Main()
  {
    Bot player = new Bot();
    player.Play();
  }
}