!  SOI 2015 Creativity Task 'Bazaar'.
!
!  Sample bot in FORTRAN 90.
!  contact: sebastian@soi.ch

program bot
  implicit none
 
  !  Game configuration.
  integer :: n, a, d, g, round
  integer, allocatable :: players(:), bids(:), auction(:)

  !  Initialize the bot.
  call init 

  !  Participate in auctions.
  do round = 1,a
    call playAuction
  end do

  call dealloc
 
  contains
    subroutine init
      implicit none

      !  Initialize random number generator.
      call random_seed

      read(*,*) n, a, d, g
      allocate(players(n))
      allocate(bids(d))
      allocate(auction(n-1))
    end subroutine init

    subroutine dealloc
      deallocate(players)
      deallocate(bids)
      deallocate(auction)
    end subroutine dealloc

    subroutine playAuction
      !  Play a single auction.
      implicit none
      integer :: i, round, coin, bid, pick
      real :: r      

      !  Distribute the available gold randomly.
      do round = 1,d
        bids(round) = 0
      end do
      do coin = 1,g
        !  Pick a random diamond.
        call random_number(r)
        pick = int(r*d)+1
        bids(pick) = bids(pick) + 1
      end do

      !  Initialize the players.
      do i = 1,n
        players(i) = g
      end do

      !  Play the auction.
      do round = 1,d
        !  Place the bid.
        write(*, '(I0)') bids(round)
        call flush

        !  Keep track of every player's gold.
        players(1) = players(1) - bids(round)
        read(*,*) auction
        do i = 2,n
          players(i) = players(i) - auction(i-1)
        end do
      end do
    end subroutine playAuction

end program bot
