//  SOI 2015 Creativity Task 'Bazaar'.
//
//  Sample bot in JavaScript (node.js).
//  contact: sebastian@soi.ch
//  node bot.js

var seed;
function rand(max) {
    seed++;
    var x = Math.abs(Math.sin(seed)*10);
    x -= Math.floor(x);
    return Math.floor(x*max);
}

function readAndContinue(callback) {
    //  Read integers from stdin and call back upon completion.
    process.stdin.resume();
    process.stdin.once('data', function(data) {
	    callback(data.toString().trim().split(' ').map(function(s) { return parseInt(s); }));
	});
}

//  Game configuration.
var n, a, d, g;
var bids, players;

function playRound(auction, round) {
    //  Play a single round.
    if (round < d) {
	//  Place the bid.
        console.log(bids[round]);

        //  Keep track of every players gold.
        readAndContinue(function(player_bids) {
		players[0] -= bids[round];
                player_bids.forEach(function(v, k) { players[k+1] -= v; } );
                
                //  Play next round.
                setTimeout(function() { playRound(auction, round+1); }, 0);
	    });
    } else {
        //  Last round finished.
        //  Play next auction.
        if (++auction < a) {
            setTimeout(function() { playAuction(auction); }, 0);
        } else {
	    process.exit(0);
        }
    }
}

function playAuction(auction) {
    //  Play a single auction.
    bids = Array.apply(null, new Array(d)).map(Number.prototype.valueOf, 0);
    players = Array.apply(null, new Array(n)).map(Number.prototype.valueOf, g);

    //  Distribute the available gold randomly.
    for (coin=0; coin<g; coin++) ++bids[rand(d)];

    //  Play the auction.
    playRound(auction, 0);
}

function play(config) {
    //  Initialize the bot.
    n = config[0]; a = config[1]; d = config[2]; g = config[3]; 

    seed = 0;

    //  Play the auctions.
    playAuction(0);
}

//  Read configuration and init bot.
readAndContinue(play);
