"""SOI 2015 Creativity Task 'Bazaar'

Sample bot in Python 3
by benjamin@soi.ch
"""

import random
import sys

def readInts():
  return [int(i) for i in input().split()]

class Bot:

  def __init__(self, n, d, g):
    """Initialize the bot."""
    random.seed(0)
    self.n = n
    self.d = d
    self.g = g

  def play_auction(self):
    """Plays a single auction.
    Distributes the available gold randomly on the diamonds."""
    bids = [0] * self.d
    for _ in range(self.g):
      bids[random.randint(0, self.d - 1)] += 1

    players_gold = [self.g] * self.n

    for i in range(self.d):
      print(bids[i])
      sys.stdout.flush()

      """Keeps track of all player's gold. Only for demonstration, not used."""
      players_gold = [x - y for x, y in zip(players_gold, [bids[i]] + readInts())]

def main():
  """Read the game parameters and start the bot."""
  n, a, d, g = readInts()
  bot = Bot(n, d, g)
  for _ in range(a):
    bot.play_auction()

if __name__ == '__main__':
  main()
