//  SOI 2015 Creativity Task 'Bazaar'
//
//  Sample bot in Scala
//  by samuel@soi.ch

import java.util.Scanner
import java.io.BufferedReader
import java.io.InputStreamReader
import scala.util.Random
import scala.collection.mutable.ArrayBuffer

object ScalaSampleBot {
  def main(args: Array[String]): Unit = {
    val sc = new Scanner(new BufferedReader(new InputStreamReader(System.in)))
    val bot = new Bot(sc)
    bot.play()
  }
}

class Bot(val in: Scanner, val n: Int, val a: Int, val d: Int, val g: Int) {

  // initialize the bot:
  def this(in: Scanner) = {
    this(in, in.nextInt(), in.nextInt(), in.nextInt(), in.nextInt())
  }
  
  // Source of randomness
  val shaker = new Random()

  // Play a single auction
  def playAuction(): Unit = {
    // Distribute the available gold randomly
    val bids = ArrayBuffer.fill(d)(0)
    for (coin <- 0 until g) bids(shaker.nextInt(d)) += 1

    // To keep track of each player's gold (each player starts with g gold pieces):
    val players = ArrayBuffer.fill(n)(g) 
  
    // Play the auction
    for (round <- 0 until d) {
      // Place the bid
      println(bids(round))
      Console.flush()

      // Keep track of every player's gold
      players(0) -= bids(round)
      for (i <- 1 until n) players(i) -= in.nextInt()
    }
  }

  def play(): Unit = {
    for (auction <- 0 until a) playAuction()
  }
}

