var game;

var rankingranks, rankingnames, rankingdiamonds;
var auctionranks, auctionnames, auctiongold, auctiondiamonds;
var roundnames, roundvalues, roundwon;
var auctionnum, roundnum, infoauctionnum, inforoundnum, playstop;

var around;

var animationtimeout, animationid;

function parseLogText(logtext){
	var lines = logtext.split("\n");
	
	var reNADG = /N = (\d+), A = (\d+), D = (\d+), G = (\d+)/;
	var rePlayers = /\d+ players: ((?:\S*, )*\S+)/;
	var reBids = /(\S+) bids (\d+)/;
	
	var obj = {};
	
	var res;
	res = reNADG.exec(lines[0]);
	
	obj.N = parseInt(res[1]);
	obj.A = parseInt(res[2]);
	obj.D = parseInt(res[3]);
	obj.G = parseInt(res[4]);
	
	res = rePlayers.exec(lines[1]);
	obj.playerids = res[1].split(", ");
	
	obj.auctions = [];
	var aline = 2;
	var lastround = {};
	
	for(var n = 0; n < obj.N; n++){
		lastround[obj.playerids[n]] = {alldiamonds: 0};
	}
	
	for(var a = 0; a < obj.A; a++){
		var newlastround = {};
		for(var id in lastround){
			newlastround[id] = {alldiamonds: lastround[id].alldiamonds, gold: obj.G, diamonds: 0};
		}
		lastround = newlastround;
		var auction = [];
		for(var d = 0; d < obj.D; d++){
			var around = {};
			var amax = 0;
			for(var n = 0; n < obj.N; n++){
				do{
					res = reBids.exec(lines[aline]);
					aline++;
				} while(res == null);
				var bid = parseInt(res[2]);
				around[res[1]] = {alldiamonds: lastround[res[1]].alldiamonds, gold: lastround[res[1]].gold - bid, diamonds: lastround[res[1]].diamonds, bid: bid, won: 0};
				amax = Math.max(amax, bid);
			}
			var amaxcount = 0;
			for(var id in around){
				if(around[id].bid == amax){
					amaxcount++;
				}
			}
			for(var id in around){
				if(around[id].bid == amax){
					around[id].won = 1 / amaxcount;
					around[id].diamonds += 1 / amaxcount;
					around[id].alldiamonds += 1 / amaxcount;
				}
			}
			auction.push(around);
			lastround = around;
		}
		obj.auctions.push(auction);
	}
	
	return obj;
}

function roundNice(x){
	return Math.round(x * 100) / 100;
}

function setGameState(state){
	var sortarray;
	
	// ranking
	rankingnames.innerHTML = "<p><b>Name</b></p>";
	rankingdiamonds.innerHTML = "<p><b>Diam.</b></p>";
	
	sortarray = [];
	for(var id in state){
		sortarray.push({id: id, val: state[id].alldiamonds});
	}
	sortarray.sort(function(a, b) {return b.val - a.val});
	
	for(var n = 0; n < game.N; n++){
		rankingnames.innerHTML += "<p>" + sortarray[n].id + "</p>";
		rankingdiamonds.innerHTML += "<p>" + roundNice(state[sortarray[n].id].alldiamonds) + "</p>";
	}
	
	// auction
	auctionnames.innerHTML = "<p><b>Name</b></p>";
	auctiongold.innerHTML = "<p><b>Gold</b></p>";
	auctiondiamonds.innerHTML = "<p><b>Diam.</b></p>";
	
	sortarray = [];
	for(var id in state){
		sortarray.push({id: id, val: state[id].diamonds});
	}
	sortarray.sort(function(a, b) {return b.val - a.val});
	
	for(var n = 0; n < game.N; n++){
		auctionnames.innerHTML += "<p>" + sortarray[n].id + "</p>";
		auctiongold.innerHTML += "<p>" + state[sortarray[n].id].gold + "</p>";
		auctiondiamonds.innerHTML += "<p>" + roundNice(state[sortarray[n].id].diamonds) + "</p>";
	}
	
	// round
	roundnames.innerHTML = "<p><b>Name</b></p>";
	roundvalues.innerHTML = "<p><b>Bid</b></p>";
	roundwon.innerHTML = "<p>&nbsp;</p>";
	
	for(var id in state){
		roundnames.innerHTML += "<p>" + id + "</p>";
		roundvalues.innerHTML += "<p>" + state[id].bid + "</p>";
		roundwon.innerHTML += (state[id].won != 0 ? "<p class=\"won\">+" + roundNice(state[id].won) : "<p>&nbsp;") + "</p>";
	}
}

function setGameStateByIndex(index){
	if(!game){
		alert("Load Log first");
	}
	
	around = index;
	while(around < 0){
		around += game.A * game.D;
	}
	around %= game.A * game.D;
	
	infoauctionnum.innerHTML = auctionnum.value = Math.floor(around / game.D) + 1;
	inforoundnum.innerHTML = roundnum.value = around % game.D + 1;
	
	setGameState(game.auctions[Math.floor(around / game.D)][around % game.D]);
}

function setRankingNumbers(n){
	rankingranks.innerHTML = "<p><b>Rank</b></p>";
	auctionranks.innerHTML = "<p><b>Rank</b></p>";
	
	for(var i = 1; i <= n; i++){
		rankingranks.innerHTML += "<p>" + i + "</p>";
		auctionranks.innerHTML += "<p>" + i + "</p>";
	}
}

function init(){
	rankingranks = document.getElementById("rankingranks");
	rankingnames = document.getElementById("rankingnames");
	rankingdiamonds = document.getElementById("rankingdiamonds");
	auctionranks = document.getElementById("auctionranks");
	auctionnames = document.getElementById("auctionnames");
	auctiongold = document.getElementById("auctiongold");
	auctiondiamonds = document.getElementById("auctiondiamonds");
	roundnames = document.getElementById("roundnames");
	roundvalues = document.getElementById("roundvalues");
	roundwon = document.getElementById("roundwon");
	
	playstop = document.getElementById("playstop");
	auctionnum = document.getElementById("auctionnum");
	roundnum = document.getElementById("roundnum");
	infoauctionnum = document.getElementById("gameinfoauctionnum");
	inforoundnum = document.getElementById("gameinforoundnum");
	
	animationtimeout = 2500;
	pause();
}

function next(){
	if(animationid != undefined && around == game.A * game.D - 2){
		pause();
	}
	
	setGameStateByIndex(around + 1);
}

function prev(){
	setGameStateByIndex(around - 1);
}

function play(){
	if(animationid != undefined){
		pause();
	}
	animationid = window.setInterval(next, animationtimeout);
	playstop.innerHTML = "Stop";
	playstop.onclick = pause;
}

function pause(){
	if(animationid != undefined){
		window.clearInterval(animationid);
		animationid = undefined;
	}
	playstop.innerHTML = "Play";
	playstop.onclick = play;
}

function onRoundChange(){
	setGameStateByIndex((parseInt(auctionnum.value)-1) * game.D + (parseInt(roundnum.value)-1));
}

function onTimeoutChange(){
	var inp = document.getElementById("animationtimeout");
	animationtimeout = parseInt(inp.value);
	if(animationid != undefined){
		pause();
		play();
	}
}

function loadLog(){
	var textarea = document.getElementById("logtext");
	game = parseLogText(textarea.value);
	
	auctionnum.max = game.A;
	auctionnum.value = 1;
	roundnum.max = game.D; 
	roundnum.value = 1;
	
	aauction = 0;
	around = 0;
	setGameState(game.auctions[aauction][around]);
	setRankingNumbers(game.N);
	
	pause();
}

function selectAllLog(){
	var textarea = document.getElementById("logtext");
	textarea.select();
}
